source: subversion/applications/utils/mod_tile/debian/renderd.init @ 15889

Last change on this file since 15889 was 15864, checked in by jochen, 11 years ago

Fixes to debian scripts

renderd starts in background mode now by default (use -fforeground for old behaviour)
File size: 3.9 KB
Line 
1#! /bin/sh
2### BEGIN INIT INFO
3# Provides:          renderd
4# Required-Start:   
5# Required-Stop:     
6# Default-Start:     2 3 4 5
7# Default-Stop:      0 1 6
8# Short-Description: Mapnik rendering daemon
9# Description:       Mapnik rendering daemon.
10### END INIT INFO
11
12# Do NOT "set -e"
13
14# PATH should only include /usr/* if it runs after the mountnfs.sh script
15PATH=/sbin:/usr/sbin:/bin:/usr/bin
16DESC="Mapnik rendering daemon"
17NAME=renderd
18DAEMON=/usr/bin/$NAME
19DAEMON_ARGS=""
20PIDFILE=/var/run/$NAME/$NAME.pid
21SCRIPTNAME=/etc/init.d/$NAME
22
23# Exit if the package is not installed
24[ -x "$DAEMON" ] || exit 0
25
26# Read configuration variable file if it is present
27[ -r /etc/default/$NAME ] && . /etc/default/$NAME
28
29# Load the VERBOSE setting and other rcS variables
30. /lib/init/vars.sh
31
32# Define LSB log_* functions.
33# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
34. /lib/lsb/init-functions
35
36#
37# Function that starts the daemon/service
38#
39do_start()
40{
41    mkdir -p /var/run/renderd
42    chown www-data:www-data /var/run/renderd
43        # Return
44        #   0 if daemon has been started
45        #   1 if daemon was already running
46        #   2 if daemon could not be started
47        start-stop-daemon --start --quiet --pidfile $PIDFILE --chuid www-data --exec $DAEMON --test > /dev/null \
48                || return 1
49        start-stop-daemon --start --quiet --pidfile $PIDFILE --chuid www-data --exec $DAEMON -- \
50                $DAEMON_ARGS \
51                || return 2
52        # Add code here, if necessary, that waits for the process to be ready
53        # to handle requests from services started subsequently which depend
54        # on this one.  As a last resort, sleep for some time.
55}
56
57#
58# Function that stops the daemon/service
59#
60do_stop()
61{
62        # Return
63        #   0 if daemon has been stopped
64        #   1 if daemon was already stopped
65        #   2 if daemon could not be stopped
66        #   other if a failure occurred
67        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
68        RETVAL="$?"
69        [ "$RETVAL" = 2 ] && return 2
70        # Wait for children to finish too if this is a daemon that forks
71        # and if the daemon is only ever run from this initscript.
72        # If the above conditions are not satisfied then add some other code
73        # that waits for the process to drop all resources that could be
74        # needed by services started subsequently.  A last resort is to
75        # sleep for some time.
76        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
77        [ "$?" = 2 ] && return 2
78        # Many daemons don't delete their pidfiles when they exit.
79        rm -f $PIDFILE
80        return "$RETVAL"
81}
82
83#
84# Function that sends a SIGHUP to the daemon/service
85#
86do_reload() {
87        #
88        # If the daemon can reload its configuration without
89        # restarting (for example, when it is sent a SIGHUP),
90        # then implement that here.
91        #
92        start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
93        return 0
94}
95
96case "$1" in
97  start)
98        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
99        do_start
100        case "$?" in
101                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
102                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
103        esac
104        ;;
105  stop)
106        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
107        do_stop
108        case "$?" in
109                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
110                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
111        esac
112        ;;
113  #reload|force-reload)
114        #
115        # If do_reload() is not implemented then leave this commented out
116        # and leave 'force-reload' as an alias for 'restart'.
117        #
118        #log_daemon_msg "Reloading $DESC" "$NAME"
119        #do_reload
120        #log_end_msg $?
121        #;;
122  restart|force-reload)
123        #
124        # If the "reload" option is implemented then remove the
125        # 'force-reload' alias
126        #
127        log_daemon_msg "Restarting $DESC" "$NAME"
128        do_stop
129        case "$?" in
130          0|1)
131                do_start
132                case "$?" in
133                        0) log_end_msg 0 ;;
134                        1) log_end_msg 1 ;; # Old process is still running
135                        *) log_end_msg 1 ;; # Failed to start
136                esac
137                ;;
138          *)
139                # Failed to stop
140                log_end_msg 1
141                ;;
142        esac
143        ;;
144  *)
145        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
146        echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
147        exit 3
148        ;;
149esac
150
151:
Note: See TracBrowser for help on using the repository browser.